﻿Imports System.ComponentModel.DataAnnotations

''' <summary>
''' Basisklasse für alles Models - übernimmt eigendlich die ganze logik für die Defaultspalten
''' So kann jede Modelklasse einfach diese Logik mit Implementieren
''' </summary>
Public MustInherit Class ModelBase



    ''' <summary>
    ''' Setzt von wem der Datensatz erstellt wurde (z.b. Username) oder gibt diesen zurück
    ''' </summary>
    Public Overridable Property CreatedBy As String = Environment.UserName



    ''' <summary>
    ''' Setzt auf welcher Maschine der Datensatz erstellt wurde oder gibt diesen zurück
    ''' </summary>
    Public Overridable Property CreatedOn As String = Environment.MachineName


    ''' <summary>
    ''' Setzt durch wem (z.b. Username) der Datensatz zuletzt geändert wurde oder gibt ihn zurück
    ''' </summary>
    Public Overridable Property LastUpdateBy As String = Environment.UserName
    ''' <summary>
    ''' Setzt auf welcher Maschine der Datensatz zuletzt geändert wurde oder gibt diese zurück
    ''' </summary>
    Public Overridable Property LastUpdateOn As String = Environment.MachineName

    <Timestamp>
    Public Overridable Property RowVersion As Byte()



End Class
