﻿Imports System.ComponentModel
Imports System.ComponentModel.DataAnnotations
Imports Model.Interfaces

Public Class WorkCenter
    Inherits ModelBase
    Implements ILogicalDelete
    Implements ILogicalTimestamp

    Public Sub New()

    End Sub

    Public Sub New(name As String, capacity As Integer)
        Me.Name = name : Me.Capacity = capacity
    End Sub

    <Key>
    Public Property Id As Integer
    <Required>
    <MaxLength(50)>
    <MinLength(3)>
    Public Property Name As String

    <Required>
    <DefaultValue(10)>
    Public Property Capacity As Integer

    Public Property AssociatedOrders As ICollection(Of Order)

    Public Property DeletedFlag As Boolean Implements ILogicalDelete.DeletedFlag

    Public Property DeletedTimestamp As Date? Implements ILogicalDelete.DeletedTimestamp

    Public Property LastUpdateTimestamp As Date? Implements ILogicalTimestamp.LastUpdateTimestamp

    Public Property CreationTimestamp As Date? Implements ILogicalTimestamp.CreationTimestamp

End Class
