﻿Imports Model

Namespace Workspaces
    Public Class AnswerVm
        Inherits ViewModelBase


        Private ReadOnly _answer As Answer

        Public Sub New()
            If IsInDesignMode Then
                _answer = New Answer() With {.AnswerText = "Das ist der Antworttext welcher zur Designzeit zur verfügung gestellt wird.", .ContactName = "Design Kontaktname", .RequestDate = DateTime.Now}
            Else
                _answer = New Answer
            End If
        End Sub

        Public Sub New(answerObj As Answer)
            _answer = answerObj
        End Sub


#Region "Properties"


        Public Property Id As Integer
            Get
                Return _answer.Id
            End Get
            Set(value As Integer)
                _answer.Id = value
                RaisePropertyChanged()
            End Set
        End Property

        Public Property Contact As String
            Get
                Return _answer.ContactName
            End Get
            Set
                _answer.ContactName = Value
                RaisePropertyChanged()
            End Set
        End Property

        Public Property RequestDate As Nullable(Of Date)
            Get
                Return _answer.RequestDate
            End Get
            Set
                _answer.RequestDate = Value
                RaisePropertyChanged()
            End Set
        End Property

        Public Property AnswerText As String
            Get
                Return _answer.AnswerText
            End Get
            Set
                _answer.AnswerText = Value
                RaisePropertyChanged()
            End Set
        End Property



        Public Property IsDeleted() As Boolean
            Get
                Return _answer.DeletedFlag
            End Get
            Set(ByVal value As Boolean)
                _answer.DeletedFlag = value
                If value Then
                    _answer.DeletedTimestamp = DateTime.Now
                Else
                    _answer.DeletedTimestamp = Nothing
                End If
                RaisePropertyChanged()
                RaisePropertyChanged("DeletedTimestamp")
            End Set
        End Property

        Public ReadOnly Property DeletedTimestamp() As DateTime?
            Get
                Return _answer.DeletedTimestamp
            End Get
        End Property


        Public ReadOnly Property LastUpdateTimestamp As DateTime?
            Get
                Return _answer.LastUpdateTimestamp
            End Get
        End Property

        Public ReadOnly Property CreationTimestamp As DateTime?
            Get
                Return _answer.CreationTimestamp
            End Get
        End Property

        Public ReadOnly Property CreatedBy As String
            Get
                Return _answer.CreatedBy
            End Get
        End Property

        Public ReadOnly Property CreatedOn As String
            Get
                Return _answer.CreatedOn
            End Get
        End Property


        Public ReadOnly Property LastUpdateBy As String
            Get
                Return _answer.LastUpdateBy
            End Get
        End Property

        Public ReadOnly Property LastUpdateOn As String
            Get
                Return _answer.LastUpdateOn
            End Get
        End Property




#End Region



        Friend Function GetModelAnswerObject() As Answer
            Return _answer
        End Function

    End Class
End Namespace